//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%40C0ABEC0300.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%40C0ABEC0300.cm

//## begin module%40C0ABEC0300.cp preserve=no
//## end module%40C0ABEC0300.cp

//## Module: FitErrorCalc%40C0ABEC0300; Package specification
//## Subsystem: XSFit::Fit%3677C9158350
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/Fit/FitErrorCalc.h

#ifndef FITERRORCALC_H
#define FITERRORCALC_H 1

//## begin module%40C0ABEC0300.additionalIncludes preserve=no
//## end module%40C0ABEC0300.additionalIncludes

//## begin module%40C0ABEC0300.includes preserve=yes
#include <xsTypes.h>
//## end module%40C0ABEC0300.includes

// Error
#include <XSUtil/Error/Error.h>

class Fit;

//## begin module%40C0ABEC0300.declarations preserve=no
//## end module%40C0ABEC0300.declarations

//## begin module%40C0ABEC0300.additionalDeclarations preserve=yes
class ModParam;
//## end module%40C0ABEC0300.additionalDeclarations


//## begin FitErrorCalc%40C0AD2A0262.preface preserve=yes
//## end FitErrorCalc%40C0AD2A0262.preface

//## Class: FitErrorCalc%40C0AD2A0262
//## Category: XSFit::Fit%36349D710188
//## Subsystem: XSFit::Fit%3677C9158350
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%40C0AE4000AE;Fit { -> F}

class FitErrorCalc 
{
  //## begin FitErrorCalc%40C0AD2A0262.initialDeclarations preserve=yes
  //## end FitErrorCalc%40C0AD2A0262.initialDeclarations

  public:
    //## Class: ErrorCalcError%40C0B7A20292
    //## Category: XSFit::Fit%36349D710188
    //## Subsystem: XSFit::Fit%3677C9158350
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class ErrorCalcError : public YellowAlert  //## Inherits: <unnamed>%40C0B7CF039E
    {
      public:
        //## Constructors (specified)
          //## Operation: ErrorCalcError%40C0B84A0158
          ErrorCalcError (const string& msg);

      protected:
      private:
      private: //## implementation
    };

    //## Class: Coord2D%40C4E1DA030A
    //## Category: XSFit::Fit%36349D710188
    //## Subsystem: XSFit::Fit%3677C9158350
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef std::pair<Real,Real> Coord2D;

    //## Class: ParamCalcError%40C5E3000084
    //## Category: XSFit::Fit%36349D710188
    //## Subsystem: XSFit::Fit%3677C9158350
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class ParamCalcError : public YellowAlert  //## Inherits: <unnamed>%40C5E3300226
    {
      public:
        //## Constructors (specified)
          //## Operation: ParamCalcError%40C5E3960160
          ParamCalcError (const string& msg);

      protected:
      private:
      private: //## implementation
    };

    //## Class: NewMinFound%42443A030001
    //## Category: XSFit::Fit%36349D710188
    //## Subsystem: XSFit::Fit%3677C9158350
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class NewMinFound : public YellowAlert  //## Inherits: <unnamed>%42443A560065
    {
      public:
        //## Constructors (specified)
          //## Operation: NewMinFound%42443DD601AC
          NewMinFound ();

      protected:
      private:
      private: //## implementation
    };

    //## Class: ErrorCalcCodes%43175CCA00F0
    //## Category: XSFit::Fit%36349D710188
    //## Subsystem: XSFit::Fit%3677C9158350
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef enum {OK=0, NEWMIN=1, NONMON=2, GENPROB=4, LOWLIM=8, UPLIM=16, FROZEPAR=32, NEGFAIL=64, POSFAIL=128, TOOLARGE=256}  ErrorCalcCodes;

    //## Constructors (specified)
      //## Operation: FitErrorCalc%40C0ADB0007B
      FitErrorCalc (Fit* fit, const string& modelName, const IntegerArray& iParams);

    //## Destructor (generated)
      ~FitErrorCalc();


    //## Other Operations (specified)
      //## Operation: perform%40C0B4AF0193
      void perform ();

      //## Operation: fit3Points%40C4E45300ED
      static int fit3Points (const std::vector<Coord2D >& fitPoints, std::vector<Real>& coeffs);

      //## Operation: fit2Points%40C4E4DB0039
      static int fit2Points (const std::vector<Coord2D >& fitPoints, std::vector<Real>& coeffs);

      //## Operation: errCodeToString%43468D90004B
      static string errCodeToString (FitErrorCalc::ErrorCalcCodes errCode);

      //## Operation: stringToErrCode%4346E08100BD
      static FitErrorCalc::ErrorCalcCodes stringToErrCode (const string& errString);

      //## Operation: setAllErrParamStrings%434C05330140
      static void setAllErrParamStrings (Fit* fit, const IntegerArray& iParams, FitErrorCalc::ErrorCalcCodes code);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: status%4317641F01E4
      FitErrorCalc::ErrorCalcCodes status () const;

  public:
    // Additional Public Declarations
      //## begin FitErrorCalc%40C0AD2A0262.public preserve=yes
      //## end FitErrorCalc%40C0AD2A0262.public

  protected:
    // Additional Protected Declarations
      //## begin FitErrorCalc%40C0AD2A0262.protected preserve=yes
      //## end FitErrorCalc%40C0AD2A0262.protected

  private:

    //## Other Operations (specified)
      //## Operation: interpolate%40C0B30802E2
      void interpolate ();

      //## Operation: calcUncertainty%40C0B4D40093
      void calcUncertainty ();

      //## Operation: reportParameter%40C5F8220216
      void reportParameter () const;

      //## Operation: commonRestore%40C8A48E00A8
      void commonRestore ();

      //## Operation: resetFit%40C9CF900123
      void resetFit ();

    // Additional Private Declarations
      //## begin FitErrorCalc%40C0AD2A0262.private preserve=yes
      //## end FitErrorCalc%40C0AD2A0262.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: fit%40C0AEA20028
      //## begin FitErrorCalc::fit%40C0AEA20028.attr preserve=no  private: Fit* {U} 
      Fit* m_fit;
      //## end FitErrorCalc::fit%40C0AEA20028.attr

      //## Attribute: params%40C0AEE80281
      //## begin FitErrorCalc::params%40C0AEE80281.attr preserve=no  private: const IntegerArray {U} 
      const IntegerArray m_params;
      //## end FitErrorCalc::params%40C0AEE80281.attr

      //## Attribute: modelName%40C0AF270072
      //## begin FitErrorCalc::modelName%40C0AF270072.attr preserve=no  private: const string {U} 
      const string m_modelName;
      //## end FitErrorCalc::modelName%40C0AF270072.attr

      //## Attribute: direction%40C0B3DE016A
      //## begin FitErrorCalc::direction%40C0B3DE016A.attr preserve=no  private: int {U} 
      int m_direction;
      //## end FitErrorCalc::direction%40C0B3DE016A.attr

      //## Attribute: savedChatter%40C0BCBD02E4
      //## begin FitErrorCalc::savedChatter%40C0BCBD02E4.attr preserve=no  private: int {U} 
      int m_savedChatter;
      //## end FitErrorCalc::savedChatter%40C0BCBD02E4.attr

      //## Attribute: bestStat%40C0BD45010B
      //## begin FitErrorCalc::bestStat%40C0BD45010B.attr preserve=no  private: Real {U} 
      Real m_bestStat;
      //## end FitErrorCalc::bestStat%40C0BD45010B.attr

      //## Attribute: deltaStat%40C4DF0300DF
      //## begin FitErrorCalc::deltaStat%40C4DF0300DF.attr preserve=no  private: Real {U} 
      Real m_deltaStat;
      //## end FitErrorCalc::deltaStat%40C4DF0300DF.attr

      //## Attribute: currentDeltaStat%40C4DF380231
      //## begin FitErrorCalc::currentDeltaStat%40C4DF380231.attr preserve=no  private: Real {U} 
      Real m_currentDeltaStat;
      //## end FitErrorCalc::currentDeltaStat%40C4DF380231.attr

      //## Attribute: hardLimit%40C4DF74035F
      //## begin FitErrorCalc::hardLimit%40C4DF74035F.attr preserve=no  private: Real {U} 
      Real m_hardLimit;
      //## end FitErrorCalc::hardLimit%40C4DF74035F.attr

      //## Attribute: xTrial%40C4DFB60264
      //## begin FitErrorCalc::xTrial%40C4DFB60264.attr preserve=no  private: Real {U} 
      Real m_xTrial;
      //## end FitErrorCalc::xTrial%40C4DFB60264.attr

      //## Attribute: limits%40C4E2D402B6
      //## begin FitErrorCalc::limits%40C4E2D402B6.attr preserve=no  private: std::pair<Coord2D,Coord2D > {U} 
      std::pair<Coord2D,Coord2D > m_limits;
      //## end FitErrorCalc::limits%40C4E2D402B6.attr

      //## Attribute: coeffs%40C4E39E02FC
      //## begin FitErrorCalc::coeffs%40C4E39E02FC.attr preserve=no  private: std::vector<Real> {U} 
      std::vector<Real> m_coeffs;
      //## end FitErrorCalc::coeffs%40C4E39E02FC.attr

      //## Attribute: interpPoints%40C4E3CE036B
      //## begin FitErrorCalc::interpPoints%40C4E3CE036B.attr preserve=no  private: std::vector<Coord2D > {U} 
      std::vector<Coord2D > m_interpPoints;
      //## end FitErrorCalc::interpPoints%40C4E3CE036B.attr

      //## Attribute: currentPar%40C6001600CC
      //## begin FitErrorCalc::currentPar%40C6001600CC.attr preserve=no  private: ModParam* {U} 
      ModParam* m_currentPar;
      //## end FitErrorCalc::currentPar%40C6001600CC.attr

      //## Attribute: fullIndex%40C739EF02E6
      //## begin FitErrorCalc::fullIndex%40C739EF02E6.attr preserve=no  private: int {U} 
      int m_fullIndex;
      //## end FitErrorCalc::fullIndex%40C739EF02E6.attr

      //## Attribute: bestParValue%40C8A475017C
      //## begin FitErrorCalc::bestParValue%40C8A475017C.attr preserve=no  private: Real {U} 
      Real m_bestParValue;
      //## end FitErrorCalc::bestParValue%40C8A475017C.attr

      //## Attribute: savedNumFitTrials%40C8B8F9037A
      //## begin FitErrorCalc::savedNumFitTrials%40C8B8F9037A.attr preserve=no  private: int {U} 
      int m_savedNumFitTrials;
      //## end FitErrorCalc::savedNumFitTrials%40C8B8F9037A.attr

      //## begin FitErrorCalc::status%4317641F01E4.attr preserve=no  public: FitErrorCalc::ErrorCalcCodes {U} 
      FitErrorCalc::ErrorCalcCodes m_status;
      //## end FitErrorCalc::status%4317641F01E4.attr

    // Additional Implementation Declarations
      //## begin FitErrorCalc%40C0AD2A0262.implementation preserve=yes
      //## end FitErrorCalc%40C0AD2A0262.implementation

};

//## begin FitErrorCalc%40C0AD2A0262.postscript preserve=yes
//## end FitErrorCalc%40C0AD2A0262.postscript

// Class FitErrorCalc::ErrorCalcError 

// Class FitErrorCalc::ParamCalcError 

// Class FitErrorCalc::NewMinFound 

// Class FitErrorCalc 

//## Get and Set Operations for Class Attributes (inline)

inline FitErrorCalc::ErrorCalcCodes FitErrorCalc::status () const
{
  //## begin FitErrorCalc::status%4317641F01E4.get preserve=no
  return m_status;
  //## end FitErrorCalc::status%4317641F01E4.get
}

//## begin module%40C0ABEC0300.epilog preserve=yes
//## end module%40C0ABEC0300.epilog


#endif
